function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function setStyle(element, styles) {
  Object.assign(element.style, styles);
}

function rotateY(degrees) {
  return ' perspective(100em) rotateY(' + degrees + 'deg) ';
}

var Jelly =
/*#__PURE__*/
function () {
  function Jelly(id, options) {
    _classCallCheck(this, Jelly);

    this.parentNode = id;

    if (!(this.parentNode instanceof HTMLElement)) {
      this.parentNode = document.getElementById(id);
    }

    if (!this.parentNode) {
      throw new Error("No found element, document.getElementById: ".concat(id));
    }

    this.opts = Object.assign({
      interval: 90 // deg

    }, options);
    this.init();
  }

  _createClass(Jelly, [{
    key: "init",
    value: function init() {
      var _this = this;

      this.count = this.parentNode.childElementCount;
      this.countTurn = this.count * this.opts.interval;
      this.childs = Array.from(this.parentNode.children).map(function (el, i) {
        return {
          index: i,
          el: el,
          initAngle: _this.opts.interval * i,
          angle: _this.opts.interval * i,
          defaultStyle: {
            display: el.style.display
          }
        };
      });
      setStyle(this.parentNode, {
        position: 'relative'
      });
      this.childs.forEach(function (child) {
        var styles = {
          position: 'absolute',
          top: 0,
          left: 0,
          width: '100%',
          height: '100%',
          zIndex: _this.count - child.index,
          transformOrigin: 'left center'
        };

        if (child.initAngle < 90) {
          styles['transform'] = rotateY(child.initAngle);
        } else {
          styles['display'] = 'none';
        }

        setStyle(child.el, styles);
      });
    }
  }, {
    key: "run",
    value: function run() {
      var _this2 = this;

      var turn = 0;
      setInterval(function () {
        turn += 1;

        _this2.childs.forEach(function (child) {
          var initAngle = child.initAngle; // 是否是第一页在最后一段

          var isFirstPageInLast = child.index === 0 && turn > _this2.countTurn - _this2.opts.interval;
          if (isFirstPageInLast) initAngle = child.initAngle + _this2.countTurn;

          if (initAngle >= turn - 90 && initAngle <= turn + 90) {
            if (isFirstPageInLast) {
              child.angle = (initAngle - turn + _this2.countTurn) % _this2.countTurn;
            } else {
              child.angle = initAngle - turn;
            }

            child.angle %= 360;

            if (child.angle <= 90 || child >= -90) {
              var styles = {
                transform: rotateY(child.angle),
                display: child.defaultStyle.display
              };

              if (isFirstPageInLast) {
                styles.zIndex = 0;
              } else {
                styles.zIndex = _this2.count - child.index;
              }

              setStyle(child.el, styles);
              return;
            }
          } // 不用显示


          setStyle(child.el, {
            display: 'none'
          });
        });

        turn %= _this2.countTurn;
      }, 1000 / 60);
    }
  }]);

  return Jelly;
}();

export default Jelly;
